/* A Bison parser, made by GNU Bison 3.8.2.  */

/* Bison implementation for Yacc-like parsers in C

   Copyright (C) 1984, 1989-1990, 2000-2015, 2018-2021 Free Software Foundation,
   Inc.

   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.

   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* DO NOT RELY ON FEATURES THAT ARE NOT DOCUMENTED in the manual,
   especially those whose name start with YY_ or yy_.  They are
   private implementation details that can be changed or removed.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output, and Bison version.  */
#define YYBISON 30802

/* Bison version string.  */
#define YYBISON_VERSION "3.8.2"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 1

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* "%code top" blocks.  */
#line 1 "parser.yy"
 // -*-c++-*-
/*
   Copyright (C) 2017 Petr Machata
   Copyright (C) 2014, 2015 Red Hat, Inc.
   This file is part of dwgrep.

   This file is free software; you can redistribute it and/or modify
   it under the terms of either

     * the GNU Lesser General Public License as published by the Free
       Software Foundation; either version 3 of the License, or (at
       your option) any later version

   or

     * the GNU General Public License as published by the Free
       Software Foundation; either version 2 of the License, or (at
       your option) any later version

   or both in parallel, as here.

   dwgrep is distributed in the hope that it will be useful, but
   WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
   General Public License for more details.

   You should have received copies of the GNU General Public License and
   the GNU Lesser General Public License along with this program.  If
   not, see <http://www.gnu.org/licenses/>.  */

#include "parser.hh"
#include "builtin-cst.hh"

#line 102 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"



/* First part of user prologue.  */
#line 71 "parser.yy"

  #include <sstream>
  #include <iostream>

  #include "lexer.hh"
  #include "constant.hh"
  #include "tree_cr.hh"
  #include "builtin.hh"

  namespace
  {
    void
    yyerror (std::unique_ptr <tree> &t, yyscan_t lex, char const *s)
    {
      fprintf (stderr, "%s\n", s);
    }

    constant
    parse_int (strlit str)
    {
      const char *buf = str.buf;
      size_t len = str.len;

      bool sign = buf[0] == '-';
      if (sign)
	{
	  buf += 1;
	  len -= 1;
	}

      int base;
      constant_dom const *dom;
      if (len > 2 && buf[0] == '0' && (buf[1] == 'x' || buf[1] == 'X'))
	{
	  base = 16;
	  buf += 2;
	  len -= 2;
	  dom = &hex_constant_dom;
	}
      else if (len > 2 && buf[0] == '0' && (buf[1] == 'b' || buf[1] == 'B'))
	{
	  base = 2;
	  buf += 2;
	  len -= 2;
	  dom = &bin_constant_dom;
	}
      else if (len > 2 && buf[0] == '0' && (buf[1] == 'o' || buf[1] == 'O'))
	{
	  base = 8;
	  buf += 2;
	  len -= 2;
	  dom = &oct_constant_dom;
	}
      else if (len > 1 && buf[0] == '0')
	{
	  base = 8;
	  buf += 1;
	  len -= 1;
	  dom = &oct_constant_dom;
	}
      else
	{
	  base = 10;
	  dom = &dec_constant_dom;
	}

      uint64_t val;
      try
	{
	  size_t pos;
	  val = std::stoull ({buf, len}, &pos, base);
	  if (pos < len)
	    throw std::runtime_error
	      (std::string ("Invalid integer literal: `") + str.buf + "'");
	}
      catch (std::out_of_range const &e)
	{
          // Translate this particular exception so that the message is
          // meaningful.
	  throw std::runtime_error
	    (std::string ("Integer literal out of range: `") + str.buf + "'");
	}

      mpz_class ret = val;
      if (sign)
	ret = -ret;

      return constant {ret, dom};
    }

    std::unique_ptr <tree>
    parse_word (std::string str)
    {
      return tree::create_str <tree_type::READ> (str);
    }

    std::unique_ptr <tree>
    parse_numword (strlit str)
    {
      assert (str.len > 1);
      bool positive = str.buf[0] == '?';
      ++str.buf;
      --str.len;

      auto val = parse_int (str).value ();
      assert (val.is_unsigned ());

      uint64_t pos64 = val.uval();
      size_t pos = static_cast <size_t> (pos64);
      if (pos != pos64)
        throw std::runtime_error
          (std::string ("Position assertion too large: `") + str.buf + "'");

      auto bi = std::make_shared <builtin_pred_pos> (positive, pos);
      return tree::create_builtin (bi);
    }

    std::unique_ptr <tree>
    tree_for_id_block (std::vector <std::string> const &ids)
    {
      std::unique_ptr <tree> ret;
      for (auto const &s: ids)
	{
	  std::unique_ptr <tree> t {tree::create_str <tree_type::BIND> (s)};
	  ret = tree::create_cat <tree_type::CAT>
	    (std::move (ret), std::move (t));
	}

      return ret;
    }

    std::unique_ptr <tree>
    tree_for_id_block (std::unique_ptr <std::vector <std::string>> ids)
    {
      return tree_for_id_block (*ids);
    }

    std::unique_ptr <tree>
    nop ()
    {
      return tree::create_nullary <tree_type::NOP> ();
    }

    std::unique_ptr <tree>
    maybe_nop (std::unique_ptr <tree> t)
    {
      return t != nullptr ? std::move (t) : nop ();
    }

    std::unique_ptr <tree>
    wrap_in_scope_unless (tree_type tt, std::unique_ptr <tree> t)
    {
      auto ret = maybe_nop (std::move (t));
      if (ret->tt () != tt)
	ret = tree::create_scope (std::move (ret));
      return ret;
    }

    std::unique_ptr <tree>
    parse_op_tmplet (std::string const &name, std::unique_ptr <tree> t)
    {
      auto one = constant {1, &dec_constant_dom};
      auto tt = tree::create_const <tree_type::SUBX_EVAL> (one);
      tt->take_child (tree::create_scope (maybe_nop (std::move (t))));

      return tree::create_cat <tree_type::CAT> (std::move (tt),
						tree_for_id_block ({name}));
    }

    std::unique_ptr <tree>
    parse_op (std::unique_ptr <tree> a,
	      std::unique_ptr <tree> b,
	      std::string const &word)
    {
      auto ta = parse_op_tmplet ("~a~", std::move (a));
      ta->take_child (parse_op_tmplet ("~b~", std::move (b)));
      ta->take_child (parse_word ("~a~"));
      ta->take_child (parse_word ("~b~"));
      ta->take_child (parse_word (word));

      return tree::create_assert
	(tree::create_unary <tree_type::PRED_SUBX_ANY>
	 (tree::create_scope (std::move (ta))));
    }

    std::unique_ptr <tree>
    parse_let (std::unique_ptr <std::vector <std::string>> ids,
	       std::unique_ptr <tree> subx)
    {
      auto tt = tree::create_const <tree_type::SUBX_EVAL>
	(constant {ids->size (), &dec_constant_dom});
      tt->take_child (tree::create_scope (std::move (subx)));

      auto ret = tree::create_cat <tree_type::CAT>
	(std::move (tt),
	 tree_for_id_block (std::move (ids)));

      return ret;
    }

    std::unique_ptr <tree>
    parse_subx (std::unique_ptr <std::vector <std::string>> ids,
		std::unique_ptr <tree> subx,
		bool force_scope = false)
    {
      size_t sz = ids->size ();
      auto ret = tree::create_cat <tree_type::CAT>
	(tree_for_id_block (std::move (ids)),
	 std::move (subx));

      if (force_scope || sz > 0)
	ret = tree::create_scope (std::move (ret));

      return ret;
    }
  }

  fmtlit::fmtlit (bool a_raw)
    : t {tree_type::FORMAT}
    , level {0}
    , in_string {false}
    , raw {a_raw}
  {}

  void
  fmtlit::flush_str ()
  {
    t.take_child (tree::create_str <tree_type::STR> (str));
    str = "";
  }

  std::string
  fmtlit::yank_str ()
  {
    std::string tmp = str;
    str = "";
    return tmp;
  }

#line 347 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"

# ifndef YY_CAST
#  ifdef __cplusplus
#   define YY_CAST(Type, Val) static_cast<Type> (Val)
#   define YY_REINTERPRET_CAST(Type, Val) reinterpret_cast<Type> (Val)
#  else
#   define YY_CAST(Type, Val) ((Type) (Val))
#   define YY_REINTERPRET_CAST(Type, Val) ((Type) (Val))
#  endif
# endif
# ifndef YY_NULLPTR
#  if defined __cplusplus
#   if 201103L <= __cplusplus
#    define YY_NULLPTR nullptr
#   else
#    define YY_NULLPTR 0
#   endif
#  else
#   define YY_NULLPTR ((void*)0)
#  endif
# endif

#include "parser.hh"
/* Symbol kind.  */
enum yysymbol_kind_t
{
  YYSYMBOL_YYEMPTY = -2,
  YYSYMBOL_YYEOF = 0,                      /* "end of file"  */
  YYSYMBOL_YYerror = 1,                    /* error  */
  YYSYMBOL_YYUNDEF = 2,                    /* "invalid token"  */
  YYSYMBOL_TOK_LPAREN = 3,                 /* TOK_LPAREN  */
  YYSYMBOL_TOK_RPAREN = 4,                 /* TOK_RPAREN  */
  YYSYMBOL_TOK_QMARK_LPAREN = 5,           /* TOK_QMARK_LPAREN  */
  YYSYMBOL_TOK_BANG_LPAREN = 6,            /* TOK_BANG_LPAREN  */
  YYSYMBOL_TOK_LBRACKET = 7,               /* TOK_LBRACKET  */
  YYSYMBOL_TOK_RBRACKET = 8,               /* TOK_RBRACKET  */
  YYSYMBOL_TOK_LBRACE = 9,                 /* TOK_LBRACE  */
  YYSYMBOL_TOK_RBRACE = 10,                /* TOK_RBRACE  */
  YYSYMBOL_TOK_QMARK_LBRACE = 11,          /* TOK_QMARK_LBRACE  */
  YYSYMBOL_TOK_BANG_LBRACE = 12,           /* TOK_BANG_LBRACE  */
  YYSYMBOL_TOK_ASTERISK = 13,              /* TOK_ASTERISK  */
  YYSYMBOL_TOK_PLUS = 14,                  /* TOK_PLUS  */
  YYSYMBOL_TOK_QMARK = 15,                 /* TOK_QMARK  */
  YYSYMBOL_TOK_COMMA = 16,                 /* TOK_COMMA  */
  YYSYMBOL_TOK_COLON = 17,                 /* TOK_COLON  */
  YYSYMBOL_TOK_SEMICOLON = 18,             /* TOK_SEMICOLON  */
  YYSYMBOL_TOK_VBAR = 19,                  /* TOK_VBAR  */
  YYSYMBOL_TOK_DOUBLE_VBAR = 20,           /* TOK_DOUBLE_VBAR  */
  YYSYMBOL_TOK_ASSIGN = 21,                /* TOK_ASSIGN  */
  YYSYMBOL_TOK_IF = 22,                    /* TOK_IF  */
  YYSYMBOL_TOK_THEN = 23,                  /* TOK_THEN  */
  YYSYMBOL_TOK_ELSE = 24,                  /* TOK_ELSE  */
  YYSYMBOL_TOK_LET = 25,                   /* TOK_LET  */
  YYSYMBOL_TOK_WORD = 26,                  /* TOK_WORD  */
  YYSYMBOL_TOK_NUMWORD = 27,               /* TOK_NUMWORD  */
  YYSYMBOL_TOK_OP = 28,                    /* TOK_OP  */
  YYSYMBOL_TOK_LIT_STR = 29,               /* TOK_LIT_STR  */
  YYSYMBOL_TOK_LIT_INT = 30,               /* TOK_LIT_INT  */
  YYSYMBOL_TOK_DEBUG = 31,                 /* TOK_DEBUG  */
  YYSYMBOL_TOK_EOF = 32,                   /* TOK_EOF  */
  YYSYMBOL_YYACCEPT = 33,                  /* $accept  */
  YYSYMBOL_Query = 34,                     /* Query  */
  YYSYMBOL_Program = 35,                   /* Program  */
  YYSYMBOL_AltList = 36,                   /* AltList  */
  YYSYMBOL_OrList = 37,                    /* OrList  */
  YYSYMBOL_OpList = 38,                    /* OpList  */
  YYSYMBOL_StatementList = 39,             /* StatementList  */
  YYSYMBOL_IdListOpt = 40,                 /* IdListOpt  */
  YYSYMBOL_IdList = 41,                    /* IdList  */
  YYSYMBOL_IdBlockOpt = 42,                /* IdBlockOpt  */
  YYSYMBOL_Statement = 43,                 /* Statement  */
  YYSYMBOL_Word = 44                       /* Word  */
};
typedef enum yysymbol_kind_t yysymbol_kind_t;




#ifdef short
# undef short
#endif

/* On compilers that do not define __PTRDIFF_MAX__ etc., make sure
   <limits.h> and (if available) <stdint.h> are included
   so that the code can choose integer types of a good width.  */

#ifndef __PTRDIFF_MAX__
# include <limits.h> /* INFRINGES ON USER NAME SPACE */
# if defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stdint.h> /* INFRINGES ON USER NAME SPACE */
#  define YY_STDINT_H
# endif
#endif

/* Narrow types that promote to a signed type and that can represent a
   signed or unsigned integer of at least N bits.  In tables they can
   save space and decrease cache pressure.  Promoting to a signed type
   helps avoid bugs in integer arithmetic.  */

#ifdef __INT_LEAST8_MAX__
typedef __INT_LEAST8_TYPE__ yytype_int8;
#elif defined YY_STDINT_H
typedef int_least8_t yytype_int8;
#else
typedef signed char yytype_int8;
#endif

#ifdef __INT_LEAST16_MAX__
typedef __INT_LEAST16_TYPE__ yytype_int16;
#elif defined YY_STDINT_H
typedef int_least16_t yytype_int16;
#else
typedef short yytype_int16;
#endif

/* Work around bug in HP-UX 11.23, which defines these macros
   incorrectly for preprocessor constants.  This workaround can likely
   be removed in 2023, as HPE has promised support for HP-UX 11.23
   (aka HP-UX 11i v2) only through the end of 2022; see Table 2 of
   <https://h20195.www2.hpe.com/V2/getpdf.aspx/4AA4-7673ENW.pdf>.  */
#ifdef __hpux
# undef UINT_LEAST8_MAX
# undef UINT_LEAST16_MAX
# define UINT_LEAST8_MAX 255
# define UINT_LEAST16_MAX 65535
#endif

#if defined __UINT_LEAST8_MAX__ && __UINT_LEAST8_MAX__ <= __INT_MAX__
typedef __UINT_LEAST8_TYPE__ yytype_uint8;
#elif (!defined __UINT_LEAST8_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST8_MAX <= INT_MAX)
typedef uint_least8_t yytype_uint8;
#elif !defined __UINT_LEAST8_MAX__ && UCHAR_MAX <= INT_MAX
typedef unsigned char yytype_uint8;
#else
typedef short yytype_uint8;
#endif

#if defined __UINT_LEAST16_MAX__ && __UINT_LEAST16_MAX__ <= __INT_MAX__
typedef __UINT_LEAST16_TYPE__ yytype_uint16;
#elif (!defined __UINT_LEAST16_MAX__ && defined YY_STDINT_H \
       && UINT_LEAST16_MAX <= INT_MAX)
typedef uint_least16_t yytype_uint16;
#elif !defined __UINT_LEAST16_MAX__ && USHRT_MAX <= INT_MAX
typedef unsigned short yytype_uint16;
#else
typedef int yytype_uint16;
#endif

#ifndef YYPTRDIFF_T
# if defined __PTRDIFF_TYPE__ && defined __PTRDIFF_MAX__
#  define YYPTRDIFF_T __PTRDIFF_TYPE__
#  define YYPTRDIFF_MAXIMUM __PTRDIFF_MAX__
# elif defined PTRDIFF_MAX
#  ifndef ptrdiff_t
#   include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  endif
#  define YYPTRDIFF_T ptrdiff_t
#  define YYPTRDIFF_MAXIMUM PTRDIFF_MAX
# else
#  define YYPTRDIFF_T long
#  define YYPTRDIFF_MAXIMUM LONG_MAX
# endif
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif defined __STDC_VERSION__ && 199901 <= __STDC_VERSION__
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned
# endif
#endif

#define YYSIZE_MAXIMUM                                  \
  YY_CAST (YYPTRDIFF_T,                                 \
           (YYPTRDIFF_MAXIMUM < YY_CAST (YYSIZE_T, -1)  \
            ? YYPTRDIFF_MAXIMUM                         \
            : YY_CAST (YYSIZE_T, -1)))

#define YYSIZEOF(X) YY_CAST (YYPTRDIFF_T, sizeof (X))


/* Stored state numbers (used for stacks). */
typedef yytype_int8 yy_state_t;

/* State numbers in computations.  */
typedef int yy_state_fast_t;

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(Msgid) dgettext ("bison-runtime", Msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(Msgid) Msgid
# endif
#endif


#ifndef YY_ATTRIBUTE_PURE
# if defined __GNUC__ && 2 < __GNUC__ + (96 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_PURE __attribute__ ((__pure__))
# else
#  define YY_ATTRIBUTE_PURE
# endif
#endif

#ifndef YY_ATTRIBUTE_UNUSED
# if defined __GNUC__ && 2 < __GNUC__ + (7 <= __GNUC_MINOR__)
#  define YY_ATTRIBUTE_UNUSED __attribute__ ((__unused__))
# else
#  define YY_ATTRIBUTE_UNUSED
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YY_USE(E) ((void) (E))
#else
# define YY_USE(E) /* empty */
#endif

/* Suppress an incorrect diagnostic about yylval being uninitialized.  */
#if defined __GNUC__ && ! defined __ICC && 406 <= __GNUC__ * 100 + __GNUC_MINOR__
# if __GNUC__ * 100 + __GNUC_MINOR__ < 407
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")
# else
#  define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN                           \
    _Pragma ("GCC diagnostic push")                                     \
    _Pragma ("GCC diagnostic ignored \"-Wuninitialized\"")              \
    _Pragma ("GCC diagnostic ignored \"-Wmaybe-uninitialized\"")
# endif
# define YY_IGNORE_MAYBE_UNINITIALIZED_END      \
    _Pragma ("GCC diagnostic pop")
#else
# define YY_INITIAL_VALUE(Value) Value
#endif
#ifndef YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
# define YY_IGNORE_MAYBE_UNINITIALIZED_END
#endif
#ifndef YY_INITIAL_VALUE
# define YY_INITIAL_VALUE(Value) /* Nothing. */
#endif

#if defined __cplusplus && defined __GNUC__ && ! defined __ICC && 6 <= __GNUC__
# define YY_IGNORE_USELESS_CAST_BEGIN                          \
    _Pragma ("GCC diagnostic push")                            \
    _Pragma ("GCC diagnostic ignored \"-Wuseless-cast\"")
# define YY_IGNORE_USELESS_CAST_END            \
    _Pragma ("GCC diagnostic pop")
#endif
#ifndef YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_BEGIN
# define YY_IGNORE_USELESS_CAST_END
#endif


#define YY_ASSERT(E) ((void) (0 && (E)))

#if 1

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
      /* Use EXIT_SUCCESS as a witness for stdlib.h.  */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's 'empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
             && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* 1 */

#if (! defined yyoverflow \
     && (! defined __cplusplus \
         || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yy_state_t yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (YYSIZEOF (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (YYSIZEOF (yy_state_t) + YYSIZEOF (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)                           \
    do                                                                  \
      {                                                                 \
        YYPTRDIFF_T yynewbytes;                                         \
        YYCOPY (&yyptr->Stack_alloc, Stack, yysize);                    \
        Stack = &yyptr->Stack_alloc;                                    \
        yynewbytes = yystacksize * YYSIZEOF (*Stack) + YYSTACK_GAP_MAXIMUM; \
        yyptr += yynewbytes / YYSIZEOF (*yyptr);                        \
      }                                                                 \
    while (0)

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from SRC to DST.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(Dst, Src, Count) \
      __builtin_memcpy (Dst, Src, YY_CAST (YYSIZE_T, (Count)) * sizeof (*(Src)))
#  else
#   define YYCOPY(Dst, Src, Count)              \
      do                                        \
        {                                       \
          YYPTRDIFF_T yyi;                      \
          for (yyi = 0; yyi < (Count); yyi++)   \
            (Dst)[yyi] = (Src)[yyi];            \
        }                                       \
      while (0)
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  36
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   91

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  33
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  12
/* YYNRULES -- Number of rules.  */
#define YYNRULES  37
/* YYNSTATES -- Number of states.  */
#define YYNSTATES  78

/* YYMAXUTOK -- Last valid token kind.  */
#define YYMAXUTOK   287


/* YYTRANSLATE(TOKEN-NUM) -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex, with out-of-bounds checking.  */
#define YYTRANSLATE(YYX)                                \
  (0 <= (YYX) && (YYX) <= YYMAXUTOK                     \
   ? YY_CAST (yysymbol_kind_t, yytranslate[YYX])        \
   : YYSYMBOL_YYUNDEF)

/* YYTRANSLATE[TOKEN-NUM] -- Symbol number corresponding to TOKEN-NUM
   as returned by yylex.  */
static const yytype_int8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32
};

#if YYDEBUG
/* YYRLINE[YYN] -- Source line where rule number YYN was defined.  */
static const yytype_int16 yyrline[] =
{
       0,   347,   347,   353,   363,   365,   379,   381,   395,   397,
     410,   412,   425,   429,   432,   440,   444,   448,   457,   468,
     480,   487,   502,   513,   526,   540,   548,   565,   588,   601,
     609,   623,   626,   629,   637,   646,   654,   658
};
#endif

/** Accessing symbol of state STATE.  */
#define YY_ACCESSING_SYMBOL(State) YY_CAST (yysymbol_kind_t, yystos[State])

#if 1
/* The user-facing name of the symbol whose (internal) number is
   YYSYMBOL.  No bounds checking.  */
static const char *yysymbol_name (yysymbol_kind_t yysymbol) YY_ATTRIBUTE_UNUSED;

/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "\"end of file\"", "error", "\"invalid token\"", "TOK_LPAREN",
  "TOK_RPAREN", "TOK_QMARK_LPAREN", "TOK_BANG_LPAREN", "TOK_LBRACKET",
  "TOK_RBRACKET", "TOK_LBRACE", "TOK_RBRACE", "TOK_QMARK_LBRACE",
  "TOK_BANG_LBRACE", "TOK_ASTERISK", "TOK_PLUS", "TOK_QMARK", "TOK_COMMA",
  "TOK_COLON", "TOK_SEMICOLON", "TOK_VBAR", "TOK_DOUBLE_VBAR",
  "TOK_ASSIGN", "TOK_IF", "TOK_THEN", "TOK_ELSE", "TOK_LET", "TOK_WORD",
  "TOK_NUMWORD", "TOK_OP", "TOK_LIT_STR", "TOK_LIT_INT", "TOK_DEBUG",
  "TOK_EOF", "$accept", "Query", "Program", "AltList", "OrList", "OpList",
  "StatementList", "IdListOpt", "IdList", "IdBlockOpt", "Statement",
  "Word", YY_NULLPTR
};

static const char *
yysymbol_name (yysymbol_kind_t yysymbol)
{
  return yytname[yysymbol];
}
#endif

#define YYPACT_NINF (-24)

#define yypact_value_is_default(Yyn) \
  ((Yyn) == YYPACT_NINF)

#define YYTABLE_NINF (-1)

#define yytable_value_is_error(Yyn) \
  0

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
static const yytype_int8 yypact[] =
{
      45,   -15,   -15,   -15,    23,   -15,   -15,   -15,    45,    29,
     -24,   -24,   -24,   -24,   -24,     9,   -22,   -24,     2,    -4,
       4,    14,    16,    12,    45,    45,    45,   -24,    45,    45,
      45,    45,    46,    12,    26,    28,   -24,   -24,    45,    45,
      45,   -24,   -24,   -24,   -24,    45,    34,    61,    64,    69,
      76,    73,    77,    78,    45,   -24,   -24,    45,    45,   -24,
     -24,   -24,    49,   -24,   -24,   -24,   -24,   -24,   -24,   -24,
     -24,     0,    67,    68,    45,   -24,   -24,    49
};

/* YYDEFACT[STATE-NUM] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE does not specify something else to do.  Zero
   means the default is an error.  */
static const yytype_int8 yydefact[] =
{
      10,    15,    15,    15,    15,    15,    15,    15,     0,     0,
      36,    37,    34,    31,    35,     0,     0,     3,     4,     6,
       8,    10,    32,     0,    10,    10,    10,    20,    10,    10,
      10,    10,     0,    12,     0,     0,     1,     2,    10,    10,
      10,    27,    28,    29,    11,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,    14,    13,    10,    10,     5,
       7,     9,    33,    16,    17,    18,    19,    21,    22,    23,
      24,     0,     0,     0,     0,    26,    25,    30
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int8 yypgoto[] =
{
     -24,   -24,   -23,    51,    52,   -24,   -10,   -24,   -11,    75,
      -8,   -24
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int8 yydefgoto[] =
{
       0,    15,    16,    17,    18,    19,    20,    55,    35,    24,
      21,    22
};

/* YYTABLE[YYPACT[STATE-NUM]] -- What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule whose
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
static const yytype_int8 yytable[] =
{
      32,    47,    48,    49,    23,    50,    51,    52,    53,    36,
      37,    44,    46,    41,    42,    43,    39,     1,    38,     2,
       3,     4,    56,     5,    74,     6,     7,    41,    42,    43,
      61,    27,    40,    45,    72,    73,     8,    62,    33,     9,
      10,    11,    23,    12,    13,    14,    71,    57,     1,    58,
       2,     3,     4,    63,     5,    33,     6,     7,    34,    41,
      42,    43,    41,    42,    43,    64,    77,     8,    65,    54,
       9,    10,    11,    66,    12,    13,    14,    25,    26,    28,
      29,    30,    31,    68,    67,    75,    76,    69,    70,    59,
       0,    60
};

static const yytype_int8 yycheck[] =
{
       8,    24,    25,    26,    19,    28,    29,    30,    31,     0,
      32,    21,    23,    13,    14,    15,    20,     3,    16,     5,
       6,     7,    33,     9,    24,    11,    12,    13,    14,    15,
      40,     8,    28,    17,    57,    58,    22,    45,    26,    25,
      26,    27,    19,    29,    30,    31,    54,    21,     3,    21,
       5,     6,     7,    19,     9,    26,    11,    12,    29,    13,
      14,    15,    13,    14,    15,     4,    74,    22,     4,    23,
      25,    26,    27,     4,    29,    30,    31,     2,     3,     4,
       5,     6,     7,    10,     8,    18,    18,    10,    10,    38,
      -1,    39
};

/* YYSTOS[STATE-NUM] -- The symbol kind of the accessing symbol of
   state STATE-NUM.  */
static const yytype_int8 yystos[] =
{
       0,     3,     5,     6,     7,     9,    11,    12,    22,    25,
      26,    27,    29,    30,    31,    34,    35,    36,    37,    38,
      39,    43,    44,    19,    42,    42,    42,     8,    42,    42,
      42,    42,    43,    26,    29,    41,     0,    32,    16,    20,
      28,    13,    14,    15,    39,    17,    41,    35,    35,    35,
      35,    35,    35,    35,    23,    40,    41,    21,    21,    36,
      37,    39,    43,    19,     4,     4,     4,     8,    10,    10,
      10,    43,    35,    35,    24,    18,    18,    43
};

/* YYR1[RULE-NUM] -- Symbol kind of the left-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr1[] =
{
       0,    33,    34,    35,    36,    36,    37,    37,    38,    38,
      39,    39,    40,    40,    41,    42,    42,    43,    43,    43,
      43,    43,    43,    43,    43,    43,    43,    43,    43,    43,
      43,    43,    43,    43,    43,    43,    44,    44
};

/* YYR2[RULE-NUM] -- Number of symbols on the right-hand side of rule RULE-NUM.  */
static const yytype_int8 yyr2[] =
{
       0,     2,     2,     1,     1,     3,     1,     3,     1,     3,
       0,     2,     0,     1,     2,     0,     3,     4,     4,     4,
       2,     4,     4,     4,     4,     5,     5,     2,     2,     2,
       6,     1,     1,     3,     1,     1,     1,     1
};


enum { YYENOMEM = -2 };

#define yyerrok         (yyerrstatus = 0)
#define yyclearin       (yychar = YYEMPTY)

#define YYACCEPT        goto yyacceptlab
#define YYABORT         goto yyabortlab
#define YYERROR         goto yyerrorlab
#define YYNOMEM         goto yyexhaustedlab


#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)                                    \
  do                                                              \
    if (yychar == YYEMPTY)                                        \
      {                                                           \
        yychar = (Token);                                         \
        yylval = (Value);                                         \
        YYPOPSTACK (yylen);                                       \
        yystate = *yyssp;                                         \
        goto yybackup;                                            \
      }                                                           \
    else                                                          \
      {                                                           \
        yyerror (ret, yyscanner, YY_("syntax error: cannot back up")); \
        YYERROR;                                                  \
      }                                                           \
  while (0)

/* Backward compatibility with an undocumented macro.
   Use YYerror or YYUNDEF. */
#define YYERRCODE YYUNDEF


/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)                        \
do {                                            \
  if (yydebug)                                  \
    YYFPRINTF Args;                             \
} while (0)




# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)                    \
do {                                                                      \
  if (yydebug)                                                            \
    {                                                                     \
      YYFPRINTF (stderr, "%s ", Title);                                   \
      yy_symbol_print (stderr,                                            \
                  Kind, Value, ret, yyscanner); \
      YYFPRINTF (stderr, "\n");                                           \
    }                                                                     \
} while (0)


/*-----------------------------------.
| Print this symbol's value on YYO.  |
`-----------------------------------*/

static void
yy_symbol_value_print (FILE *yyo,
                       yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, std::unique_ptr <tree> &ret, void *yyscanner)
{
  FILE *yyoutput = yyo;
  YY_USE (yyoutput);
  YY_USE (ret);
  YY_USE (yyscanner);
  if (!yyvaluep)
    return;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}


/*---------------------------.
| Print this symbol on YYO.  |
`---------------------------*/

static void
yy_symbol_print (FILE *yyo,
                 yysymbol_kind_t yykind, YYSTYPE const * const yyvaluep, std::unique_ptr <tree> &ret, void *yyscanner)
{
  YYFPRINTF (yyo, "%s %s (",
             yykind < YYNTOKENS ? "token" : "nterm", yysymbol_name (yykind));

  yy_symbol_value_print (yyo, yykind, yyvaluep, ret, yyscanner);
  YYFPRINTF (yyo, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

static void
yy_stack_print (yy_state_t *yybottom, yy_state_t *yytop)
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)                            \
do {                                                            \
  if (yydebug)                                                  \
    yy_stack_print ((Bottom), (Top));                           \
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

static void
yy_reduce_print (yy_state_t *yyssp, YYSTYPE *yyvsp,
                 int yyrule, std::unique_ptr <tree> &ret, void *yyscanner)
{
  int yylno = yyrline[yyrule];
  int yynrhs = yyr2[yyrule];
  int yyi;
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %d):\n",
             yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr,
                       YY_ACCESSING_SYMBOL (+yyssp[yyi + 1 - yynrhs]),
                       &yyvsp[(yyi + 1) - (yynrhs)], ret, yyscanner);
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)          \
do {                                    \
  if (yydebug)                          \
    yy_reduce_print (yyssp, yyvsp, Rule, ret, yyscanner); \
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args) ((void) 0)
# define YY_SYMBOL_PRINT(Title, Kind, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


/* Context of a parse error.  */
typedef struct
{
  yy_state_t *yyssp;
  yysymbol_kind_t yytoken;
} yypcontext_t;

/* Put in YYARG at most YYARGN of the expected tokens given the
   current YYCTX, and return the number of tokens stored in YYARG.  If
   YYARG is null, return the number of expected tokens (guaranteed to
   be less than YYNTOKENS).  Return YYENOMEM on memory exhaustion.
   Return 0 if there are more than YYARGN expected tokens, yet fill
   YYARG up to YYARGN. */
static int
yypcontext_expected_tokens (const yypcontext_t *yyctx,
                            yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  int yyn = yypact[+*yyctx->yyssp];
  if (!yypact_value_is_default (yyn))
    {
      /* Start YYX at -YYN if negative to avoid negative indexes in
         YYCHECK.  In other words, skip the first -YYN actions for
         this state because they are default actions.  */
      int yyxbegin = yyn < 0 ? -yyn : 0;
      /* Stay within bounds of both yycheck and yytname.  */
      int yychecklim = YYLAST - yyn + 1;
      int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
      int yyx;
      for (yyx = yyxbegin; yyx < yyxend; ++yyx)
        if (yycheck[yyx + yyn] == yyx && yyx != YYSYMBOL_YYerror
            && !yytable_value_is_error (yytable[yyx + yyn]))
          {
            if (!yyarg)
              ++yycount;
            else if (yycount == yyargn)
              return 0;
            else
              yyarg[yycount++] = YY_CAST (yysymbol_kind_t, yyx);
          }
    }
  if (yyarg && yycount == 0 && 0 < yyargn)
    yyarg[0] = YYSYMBOL_YYEMPTY;
  return yycount;
}




#ifndef yystrlen
# if defined __GLIBC__ && defined _STRING_H
#  define yystrlen(S) (YY_CAST (YYPTRDIFF_T, strlen (S)))
# else
/* Return the length of YYSTR.  */
static YYPTRDIFF_T
yystrlen (const char *yystr)
{
  YYPTRDIFF_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
# endif
#endif

#ifndef yystpcpy
# if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#  define yystpcpy stpcpy
# else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
yystpcpy (char *yydest, const char *yysrc)
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
# endif
#endif

#ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYPTRDIFF_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYPTRDIFF_T yyn = 0;
      char const *yyp = yystr;
      for (;;)
        switch (*++yyp)
          {
          case '\'':
          case ',':
            goto do_not_strip_quotes;

          case '\\':
            if (*++yyp != '\\')
              goto do_not_strip_quotes;
            else
              goto append;

          append:
          default:
            if (yyres)
              yyres[yyn] = *yyp;
            yyn++;
            break;

          case '"':
            if (yyres)
              yyres[yyn] = '\0';
            return yyn;
          }
    do_not_strip_quotes: ;
    }

  if (yyres)
    return yystpcpy (yyres, yystr) - yyres;
  else
    return yystrlen (yystr);
}
#endif


static int
yy_syntax_error_arguments (const yypcontext_t *yyctx,
                           yysymbol_kind_t yyarg[], int yyargn)
{
  /* Actual size of YYARG. */
  int yycount = 0;
  /* There are many possibilities here to consider:
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yyctx->yytoken != YYSYMBOL_YYEMPTY)
    {
      int yyn;
      if (yyarg)
        yyarg[yycount] = yyctx->yytoken;
      ++yycount;
      yyn = yypcontext_expected_tokens (yyctx,
                                        yyarg ? yyarg + 1 : yyarg, yyargn - 1);
      if (yyn == YYENOMEM)
        return YYENOMEM;
      else
        yycount += yyn;
    }
  return yycount;
}

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return -1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return YYENOMEM if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYPTRDIFF_T *yymsg_alloc, char **yymsg,
                const yypcontext_t *yyctx)
{
  enum { YYARGS_MAX = 5 };
  /* Internationalized format string. */
  const char *yyformat = YY_NULLPTR;
  /* Arguments of yyformat: reported tokens (one for the "unexpected",
     one per "expected"). */
  yysymbol_kind_t yyarg[YYARGS_MAX];
  /* Cumulated lengths of YYARG.  */
  YYPTRDIFF_T yysize = 0;

  /* Actual size of YYARG. */
  int yycount = yy_syntax_error_arguments (yyctx, yyarg, YYARGS_MAX);
  if (yycount == YYENOMEM)
    return YYENOMEM;

  switch (yycount)
    {
#define YYCASE_(N, S)                       \
      case N:                               \
        yyformat = S;                       \
        break
    default: /* Avoid compiler warnings. */
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
#undef YYCASE_
    }

  /* Compute error message size.  Don't count the "%s"s, but reserve
     room for the terminator.  */
  yysize = yystrlen (yyformat) - 2 * yycount + 1;
  {
    int yyi;
    for (yyi = 0; yyi < yycount; ++yyi)
      {
        YYPTRDIFF_T yysize1
          = yysize + yytnamerr (YY_NULLPTR, yytname[yyarg[yyi]]);
        if (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM)
          yysize = yysize1;
        else
          return YYENOMEM;
      }
  }

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return -1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yytname[yyarg[yyi++]]);
          yyformat += 2;
        }
      else
        {
          ++yyp;
          ++yyformat;
        }
  }
  return 0;
}


/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

static void
yydestruct (const char *yymsg,
            yysymbol_kind_t yykind, YYSTYPE *yyvaluep, std::unique_ptr <tree> &ret, void *yyscanner)
{
  YY_USE (yyvaluep);
  YY_USE (ret);
  YY_USE (yyscanner);
  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yykind, yyvaluep, yylocationp);

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  YY_USE (yykind);
  YY_IGNORE_MAYBE_UNINITIALIZED_END
}






/*----------.
| yyparse.  |
`----------*/

int
yyparse (std::unique_ptr <tree> &ret, void *yyscanner)
{
/* Lookahead token kind.  */
int yychar;


/* The semantic value of the lookahead symbol.  */
/* Default value used for initialization, for pacifying older GCCs
   or non-GCC compilers.  */
YY_INITIAL_VALUE (static YYSTYPE yyval_default;)
YYSTYPE yylval YY_INITIAL_VALUE (= yyval_default);

    /* Number of syntax errors so far.  */
    int yynerrs = 0;

    yy_state_fast_t yystate = 0;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus = 0;

    /* Refer to the stacks through separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* Their size.  */
    YYPTRDIFF_T yystacksize = YYINITDEPTH;

    /* The state stack: array, bottom, top.  */
    yy_state_t yyssa[YYINITDEPTH];
    yy_state_t *yyss = yyssa;
    yy_state_t *yyssp = yyss;

    /* The semantic value stack: array, bottom, top.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs = yyvsa;
    YYSTYPE *yyvsp = yyvs;

  int yyn;
  /* The return value of yyparse.  */
  int yyresult;
  /* Lookahead symbol kind.  */
  yysymbol_kind_t yytoken = YYSYMBOL_YYEMPTY;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYPTRDIFF_T yymsg_alloc = sizeof yymsgbuf;

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yychar = YYEMPTY; /* Cause a token to be read.  */

  goto yysetstate;


/*------------------------------------------------------------.
| yynewstate -- push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;


/*--------------------------------------------------------------------.
| yysetstate -- set current state (the top of the stack) to yystate.  |
`--------------------------------------------------------------------*/
yysetstate:
  YYDPRINTF ((stderr, "Entering state %d\n", yystate));
  YY_ASSERT (0 <= yystate && yystate < YYNSTATES);
  YY_IGNORE_USELESS_CAST_BEGIN
  *yyssp = YY_CAST (yy_state_t, yystate);
  YY_IGNORE_USELESS_CAST_END
  YY_STACK_PRINT (yyss, yyssp);

  if (yyss + yystacksize - 1 <= yyssp)
#if !defined yyoverflow && !defined YYSTACK_RELOCATE
    YYNOMEM;
#else
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYPTRDIFF_T yysize = yyssp - yyss + 1;

# if defined yyoverflow
      {
        /* Give user a chance to reallocate the stack.  Use copies of
           these so that the &'s don't force the real ones into
           memory.  */
        yy_state_t *yyss1 = yyss;
        YYSTYPE *yyvs1 = yyvs;

        /* Each stack pointer address is followed by the size of the
           data in use in that stack, in bytes.  This used to be a
           conditional around just the two extra args, but that might
           be undefined if yyoverflow is a macro.  */
        yyoverflow (YY_("memory exhausted"),
                    &yyss1, yysize * YYSIZEOF (*yyssp),
                    &yyvs1, yysize * YYSIZEOF (*yyvsp),
                    &yystacksize);
        yyss = yyss1;
        yyvs = yyvs1;
      }
# else /* defined YYSTACK_RELOCATE */
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
        YYNOMEM;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
        yystacksize = YYMAXDEPTH;

      {
        yy_state_t *yyss1 = yyss;
        union yyalloc *yyptr =
          YY_CAST (union yyalloc *,
                   YYSTACK_ALLOC (YY_CAST (YYSIZE_T, YYSTACK_BYTES (yystacksize))));
        if (! yyptr)
          YYNOMEM;
        YYSTACK_RELOCATE (yyss_alloc, yyss);
        YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
        if (yyss1 != yyssa)
          YYSTACK_FREE (yyss1);
      }
# endif

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YY_IGNORE_USELESS_CAST_BEGIN
      YYDPRINTF ((stderr, "Stack size increased to %ld\n",
                  YY_CAST (long, yystacksize)));
      YY_IGNORE_USELESS_CAST_END

      if (yyss + yystacksize - 1 <= yyssp)
        YYABORT;
    }
#endif /* !defined yyoverflow && !defined YYSTACK_RELOCATE */


  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;


/*-----------.
| yybackup.  |
`-----------*/
yybackup:
  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either empty, or end-of-input, or a valid lookahead.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token\n"));
      yychar = yylex (&yylval, yyscanner);
    }

  if (yychar <= YYEOF)
    {
      yychar = YYEOF;
      yytoken = YYSYMBOL_YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else if (yychar == YYerror)
    {
      /* The scanner already issued an error message, process directly
         to error recovery.  But do not keep the error token as
         lookahead, it is too special and may lead us to an endless
         loop in error recovery. */
      yychar = YYUNDEF;
      yytoken = YYSYMBOL_YYerror;
      goto yyerrlab1;
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);
  yystate = yyn;
  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END

  /* Discard the shifted token.  */
  yychar = YYEMPTY;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     '$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
  case 2: /* Query: Program TOK_EOF  */
#line 348 "parser.yy"
  {
    ret.reset ((yyvsp[-1].t));
    YYACCEPT;
  }
#line 1708 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 3: /* Program: AltList  */
#line 354 "parser.yy"
  {
    std::unique_ptr <tree> t1 {(yyvsp[0].t)};

    auto ret = maybe_nop (std::move (t1));

    (yyval.t) = ret.release ();
  }
#line 1720 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 5: /* AltList: OrList TOK_COMMA AltList  */
#line 366 "parser.yy"
  {
    std::unique_ptr <tree> t1 {(yyvsp[-2].t)};
    std::unique_ptr <tree> t3 {(yyvsp[0].t)};

    auto u1 = wrap_in_scope_unless (tree_type::ALT, maybe_nop (std::move (t1)));
    auto u3 = wrap_in_scope_unless (tree_type::ALT, maybe_nop (std::move (t3)));
    auto ret = tree::create_cat <tree_type::ALT>
		(std::move (u1), std::move (u3));

    (yyval.t) = ret.release ();
  }
#line 1736 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 7: /* OrList: OpList TOK_DOUBLE_VBAR OrList  */
#line 382 "parser.yy"
  {
    std::unique_ptr <tree> t1 {(yyvsp[-2].t)};
    std::unique_ptr <tree> t3 {(yyvsp[0].t)};

    auto u1 = wrap_in_scope_unless (tree_type::OR, maybe_nop (std::move (t1)));
    auto u3 = wrap_in_scope_unless (tree_type::OR, maybe_nop (std::move (t3)));
    auto ret = tree::create_cat <tree_type::OR> (std::move (u1),
						 std::move (u3));

    (yyval.t) = ret.release ();
  }
#line 1752 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 9: /* OpList: StatementList TOK_OP StatementList  */
#line 398 "parser.yy"
  {
    std::unique_ptr <tree> t1 {(yyvsp[-2].t)};
    std::unique_ptr <tree> t3 {(yyvsp[0].t)};
    std::string str {(yyvsp[-1].s).buf, (yyvsp[-1].s).len};

    auto ret = parse_op (std::move (t1), std::move (t3), str);

    (yyval.t) = ret.release ();
  }
#line 1766 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 10: /* StatementList: %empty  */
#line 410 "parser.yy"
  { (yyval.t) = nullptr; }
#line 1772 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 11: /* StatementList: Statement StatementList  */
#line 413 "parser.yy"
  {
    std::unique_ptr <tree> t1 {(yyvsp[-1].t)};
    std::unique_ptr <tree> t2 {(yyvsp[0].t)};

    auto ret = tree::create_cat <tree_type::CAT> (std::move (t1),
						  std::move (t2));

    (yyval.t) = ret.release ();
  }
#line 1786 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 12: /* IdListOpt: %empty  */
#line 425 "parser.yy"
  {
    (yyval.ids) = new std::vector <std::string> ();
  }
#line 1794 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 14: /* IdList: TOK_WORD IdListOpt  */
#line 433 "parser.yy"
  {
    (yyvsp[0].ids)->push_back (std::string {(yyvsp[-1].s).buf, (yyvsp[-1].s).len});
    (yyval.ids) = (yyvsp[0].ids);
  }
#line 1803 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 15: /* IdBlockOpt: %empty  */
#line 440 "parser.yy"
  {
    (yyval.ids) = new std::vector <std::string> ();
  }
#line 1811 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 16: /* IdBlockOpt: TOK_VBAR IdList TOK_VBAR  */
#line 445 "parser.yy"
  { (yyval.ids) = (yyvsp[-1].ids); }
#line 1817 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 17: /* Statement: TOK_LPAREN IdBlockOpt Program TOK_RPAREN  */
#line 449 "parser.yy"
  {
    std::unique_ptr <std::vector <std::string>> ids {(yyvsp[-2].ids)};
    std::unique_ptr <tree> t3 {(yyvsp[-1].t)};
    auto ret = parse_subx (std::move (ids), std::move (t3));

    (yyval.t) = ret.release ();
  }
#line 1829 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 18: /* Statement: TOK_QMARK_LPAREN IdBlockOpt Program TOK_RPAREN  */
#line 458 "parser.yy"
  {
    std::unique_ptr <std::vector <std::string>> ids {(yyvsp[-2].ids)};
    std::unique_ptr <tree> t3 {(yyvsp[-1].t)};
    auto subx = parse_subx (std::move (ids), std::move (t3));

    auto ret = tree::create_assert
      (tree::create_unary <tree_type::PRED_SUBX_ANY> (std::move (subx)));
    (yyval.t) = ret.release ();
  }
#line 1843 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 19: /* Statement: TOK_BANG_LPAREN IdBlockOpt Program TOK_RPAREN  */
#line 469 "parser.yy"
  {
    std::unique_ptr <std::vector <std::string>> ids {(yyvsp[-2].ids)};
    std::unique_ptr <tree> t3 {(yyvsp[-1].t)};
    auto subx = parse_subx (std::move (ids), std::move (t3));

    auto ret = tree::create_assert
      (tree::create_neg
       (tree::create_unary <tree_type::PRED_SUBX_ANY> (std::move (subx))));
    (yyval.t) = ret.release ();
  }
#line 1858 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 20: /* Statement: TOK_LBRACKET TOK_RBRACKET  */
#line 481 "parser.yy"
  {
    auto ret = tree::create_nullary <tree_type::EMPTY_LIST> ();

    (yyval.t) = ret.release ();
  }
#line 1868 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 21: /* Statement: TOK_LBRACKET IdBlockOpt Program TOK_RBRACKET  */
#line 488 "parser.yy"
  {
    std::unique_ptr <std::vector <std::string>> ids {(yyvsp[-2].ids)};
    std::unique_ptr <tree> t3 {(yyvsp[-1].t)};

    auto ret = tree::create_scope
      (tree::create_cat <tree_type::CAT>
       (tree_for_id_block (std::move (ids)),

	tree::create_unary <tree_type::CAPTURE>
	(tree::create_scope (std::move (t3)))));

    (yyval.t) = ret.release ();
  }
#line 1886 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 22: /* Statement: TOK_LBRACE IdBlockOpt Program TOK_RBRACE  */
#line 503 "parser.yy"
  {
    std::unique_ptr <std::vector <std::string>> ids {(yyvsp[-2].ids)};
    std::unique_ptr <tree> t3 {(yyvsp[-1].t)};

    auto body = parse_subx (std::move (ids), std::move (t3), true);
    auto ret = tree::create_unary <tree_type::BLOCK> (std::move (body));

    (yyval.t) = ret.release ();
  }
#line 1900 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 23: /* Statement: TOK_QMARK_LBRACE IdBlockOpt Program TOK_RBRACE  */
#line 514 "parser.yy"
  {
    std::unique_ptr <std::vector <std::string>> ids {(yyvsp[-2].ids)};
    std::unique_ptr <tree> t3 {(yyvsp[-1].t)};

    auto body = parse_subx (std::move (ids), std::move (t3), true);
    auto ret = tree::create_unary <tree_type::BLOCK>
      (tree::create_assert
       (tree::create_unary <tree_type::PRED_SUBX_ANY> (std::move (body))));

    (yyval.t) = ret.release ();
  }
#line 1916 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 24: /* Statement: TOK_BANG_LBRACE IdBlockOpt Program TOK_RBRACE  */
#line 527 "parser.yy"
  {
    std::unique_ptr <std::vector <std::string>> ids {(yyvsp[-2].ids)};
    std::unique_ptr <tree> t3 {(yyvsp[-1].t)};

    auto body = parse_subx (std::move (ids), std::move (t3), true);
    auto ret = tree::create_unary <tree_type::BLOCK>
      (tree::create_assert
       (tree::create_neg
	(tree::create_unary <tree_type::PRED_SUBX_ANY> (std::move (body)))));

    (yyval.t) = ret.release ();
  }
#line 1933 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 25: /* Statement: TOK_LET IdList TOK_ASSIGN Program TOK_SEMICOLON  */
#line 541 "parser.yy"
  {
    std::unique_ptr <std::vector <std::string>> ids {(yyvsp[-3].ids)};
    std::unique_ptr <tree> t4 {(yyvsp[-1].t)};
    auto ret = parse_let (std::move (ids), std::move (t4));
    (yyval.t) = ret.release ();
  }
#line 1944 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 26: /* Statement: TOK_LET TOK_LIT_STR TOK_ASSIGN Program TOK_SEMICOLON  */
#line 549 "parser.yy"
  {
    std::unique_ptr <tree> str {(yyvsp[-3].t)};
    if (str->tt () != tree_type::FORMAT
	|| str->m_children.size () != 1
	|| str->child (0).tt () != tree_type::STR)
      throw std::runtime_error ("String let requires a simple string");

    std::string name = str->child (0).str ();

    auto ids = std::make_unique <std::vector <std::string>> ();
    ids->emplace_back (std::move (name));
    std::unique_ptr <tree> t4 {(yyvsp[-1].t)};
    auto ret = parse_let (std::move (ids), std::move (t4));
    (yyval.t) = ret.release ();
  }
#line 1964 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 27: /* Statement: Statement TOK_ASTERISK  */
#line 566 "parser.yy"
  {
    std::unique_ptr <tree> t1 {(yyvsp[-1].t)};

    auto ret = [&] () {
      switch (t1->tt ())
	{
	case tree_type::CLOSE_STAR:
	  return std::move (t1);

	case tree_type::CLOSE_PLUS:
	  t1->m_tt = tree_type::CLOSE_STAR;
	  return std::move (t1);

	default:
	  return tree::create_unary <tree_type::CLOSE_STAR>
			(tree::create_scope (std::move (t1)));
	}
    } ();

    (yyval.t) = ret.release ();
  }
#line 1990 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 28: /* Statement: Statement TOK_PLUS  */
#line 589 "parser.yy"
  {
    std::unique_ptr <tree> t1 {(yyvsp[-1].t)};

    auto ret = (t1->tt () == tree_type::CLOSE_STAR
		|| t1->tt () == tree_type::CLOSE_PLUS)
      ? std::move (t1)
      : tree::create_unary <tree_type::CLOSE_PLUS>
		(tree::create_scope (std::move (t1)));

    (yyval.t) = ret.release ();
  }
#line 2006 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 29: /* Statement: Statement TOK_QMARK  */
#line 602 "parser.yy"
  {
    std::unique_ptr <tree> t1 {(yyvsp[-1].t)};
    std::unique_ptr <tree> n {nop ()};
    (yyval.t) = tree::create_cat <tree_type::ALT>
	(std::move (t1), std::move (n)).release ();
  }
#line 2017 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 30: /* Statement: TOK_IF Statement TOK_THEN Statement TOK_ELSE Statement  */
#line 610 "parser.yy"
  {
    std::unique_ptr <tree> t2 {(yyvsp[-4].t)};
    std::unique_ptr <tree> t4 {(yyvsp[-2].t)};
    std::unique_ptr <tree> t6 {(yyvsp[0].t)};

    auto ret = tree::create_ternary <tree_type::IFELSE>
      (tree::create_scope (std::move (t2)),
       tree::create_scope (std::move (t4)),
       tree::create_scope (std::move (t6)));

    (yyval.t) = ret.release ();
  }
#line 2034 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 31: /* Statement: TOK_LIT_INT  */
#line 624 "parser.yy"
  { (yyval.t) = tree::create_const <tree_type::CONST> (parse_int ((yyvsp[0].s))).release (); }
#line 2040 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 32: /* Statement: Word  */
#line 627 "parser.yy"
  { (yyval.t) = (yyvsp[0].t); }
#line 2046 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 33: /* Statement: Word TOK_COLON Statement  */
#line 630 "parser.yy"
  {
    std::unique_ptr <tree> t1 {(yyvsp[-2].t)};
    std::unique_ptr <tree> t3 {(yyvsp[0].t)};
    (yyval.t) = tree::create_cat <tree_type::CAT>
	(std::move (t3), std::move (t1)).release ();
  }
#line 2057 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 34: /* Statement: TOK_LIT_STR  */
#line 638 "parser.yy"
  {
    // For string literals, we get back a tree_type::FMT node with
    // children that are a mix of tree_type::STR (which are actual
    // literals) and other node types with the embedded programs.
    // That comes directly from lexer, just return it.
    (yyval.t) = (yyvsp[0].t);
  }
#line 2069 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 35: /* Statement: TOK_DEBUG  */
#line 647 "parser.yy"
  {
    auto ret = tree::create_nullary <tree_type::F_DEBUG> ();

    (yyval.t) = ret.release ();
  }
#line 2079 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 36: /* Word: TOK_WORD  */
#line 655 "parser.yy"
  { (yyval.t) = parse_word ({(yyvsp[0].s).buf, (yyvsp[0].s).len}).release (); }
#line 2085 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;

  case 37: /* Word: TOK_NUMWORD  */
#line 659 "parser.yy"
  { (yyval.t) = parse_numword ((yyvsp[0].s)).release (); }
#line 2091 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"
    break;


#line 2095 "/builddir/build/BUILD/dwgrep-0.4/build/libzwerg/parser.cc"

      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", YY_CAST (yysymbol_kind_t, yyr1[yyn]), &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;

  *++yyvsp = yyval;

  /* Now 'shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */
  {
    const int yylhs = yyr1[yyn] - YYNTOKENS;
    const int yyi = yypgoto[yylhs] + *yyssp;
    yystate = (0 <= yyi && yyi <= YYLAST && yycheck[yyi] == *yyssp
               ? yytable[yyi]
               : yydefgoto[yylhs]);
  }

  goto yynewstate;


/*--------------------------------------.
| yyerrlab -- here on detecting error.  |
`--------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYSYMBOL_YYEMPTY : YYTRANSLATE (yychar);
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
      {
        yypcontext_t yyctx
          = {yyssp, yytoken};
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == -1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = YY_CAST (char *,
                             YYSTACK_ALLOC (YY_CAST (YYSIZE_T, yymsg_alloc)));
            if (yymsg)
              {
                yysyntax_error_status
                  = yysyntax_error (&yymsg_alloc, &yymsg, &yyctx);
                yymsgp = yymsg;
              }
            else
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = YYENOMEM;
              }
          }
        yyerror (ret, yyscanner, yymsgp);
        if (yysyntax_error_status == YYENOMEM)
          YYNOMEM;
      }
    }

  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
         error, discard it.  */

      if (yychar <= YYEOF)
        {
          /* Return failure if at end of input.  */
          if (yychar == YYEOF)
            YYABORT;
        }
      else
        {
          yydestruct ("Error: discarding",
                      yytoken, &yylval, ret, yyscanner);
          yychar = YYEMPTY;
        }
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:
  /* Pacify compilers when the user code never invokes YYERROR and the
     label yyerrorlab therefore never appears in user code.  */
  if (0)
    YYERROR;
  ++yynerrs;

  /* Do not reclaim the symbols of the rule whose action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;      /* Each real token shifted decrements this.  */

  /* Pop stack until we find a state that shifts the error token.  */
  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
        {
          yyn += YYSYMBOL_YYerror;
          if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYSYMBOL_YYerror)
            {
              yyn = yytable[yyn];
              if (0 < yyn)
                break;
            }
        }

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
        YYABORT;


      yydestruct ("Error: popping",
                  YY_ACCESSING_SYMBOL (yystate), yyvsp, ret, yyscanner);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  YY_IGNORE_MAYBE_UNINITIALIZED_BEGIN
  *++yyvsp = yylval;
  YY_IGNORE_MAYBE_UNINITIALIZED_END


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", YY_ACCESSING_SYMBOL (yyn), yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturnlab;


/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturnlab;


/*-----------------------------------------------------------.
| yyexhaustedlab -- YYNOMEM (memory exhaustion) comes here.  |
`-----------------------------------------------------------*/
yyexhaustedlab:
  yyerror (ret, yyscanner, YY_("memory exhausted"));
  yyresult = 2;
  goto yyreturnlab;


/*----------------------------------------------------------.
| yyreturnlab -- parsing is finished, clean up and return.  |
`----------------------------------------------------------*/
yyreturnlab:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval, ret, yyscanner);
    }
  /* Do not reclaim the symbols of the rule whose action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
                  YY_ACCESSING_SYMBOL (+*yyssp), yyvsp, ret, yyscanner);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
  return yyresult;
}

#line 661 "parser.yy"


struct lexer
{
  yyscan_t m_sc;

  explicit lexer (char const *begin, char const *end)
  {
    if (yylex_init (&m_sc) != 0)
      throw std::runtime_error ("Can't init lexer.");
    yy_scan_bytes (begin, end - begin, m_sc);
  }

  ~lexer ()
  {
    yylex_destroy (m_sc);
  }

  lexer (lexer const &that) = delete;
};

tree
parse_query (std::string str)
{
  char const *buf = str.c_str ();
  return parse_query (buf, buf + str.length ());
}

tree
parse_subquery (std::string str)
{
  char const *buf = str.c_str ();
  return parse_subquery (buf, buf + str.length ());
}

tree
parse_query (char const *begin, char const *end)
{
  return parse_subquery (begin, end);
}

tree
parse_subquery (char const *begin, char const *end)
{
  lexer lex {begin, end};
  std::unique_ptr <tree> t;
  if (yyparse (t, lex.m_sc) == 0)
    return *t;
  throw std::runtime_error ("syntax error");
}
